<?php

error_reporting(E_ALL);
// disabilitazione WSDL cache. A conti fatti, meglio off anche in produzione
ini_set("soap.wsdl_cache_enabled", "0");

// il WSDL deve essere in locale. se si vuole evitare una serie di "fastidi"
$WSDL_URL    = "soap_2dplus_https.wsdl";
$PES_CFGFILE	= "test";
$SAMPLECONTENT = 'Pippo';

$ssl_credentials = 'democli.cred';
$ssl_cred_pass = 'pass1234';

// Funzione di debug per dump dei messaggi SOAP
function dump_xml($title, $body)
{
	$nl 	= preg_replace ("/\>\</", ">\n<", $body);
	$clean 	= htmlspecialchars ($nl);
	print "\n<B>$title</B>\n<PRE>$clean</PRE>\n";
}

$client = new SoapClient
(
	$WSDL_URL,
	array
	(
		'trace'	 	=> true, // mettere a false in esercizio
		'exceptions'  	=> 1,
		'connection_timeout' => 10,
		'local_cert'	 => $ssl_credentials,
		'passphrase' 	=> $ssl_cred_pass
	)
);

if (is_null($client)) 
{ 
	die("<HTML><B>Connessione SOAP non riuscita</B><BR></HTML>\n"); 
}

$data = base64_encode($SAMPLECONTENT);


// creazione array Input -> datib64 + file di configurazione aPES da utilizzare

$request_array = array
(
	"b64data"	=> $data,
	"config_file" 	=> urlencode($PES_CFGFILE)
);
$request_object = (object) $request_array; // PHP_SOAP vuole un object


// chiamata SOAP

try
{
	$output_object =  $client->get2DPlus1($request_object);
}
catch (SoapFault $Err)
{
	echo "<b>Errore SOAP: " . $Err . "</b><br>";
	// debug:
	dump_xml ("Request Headers", $client->__getLastRequestHeaders());
	dump_xml ("Request", $client->__getLastRequest());
	dump_xml ("Response Headers", $client->__getLastResponseHeaders());
	dump_xml ("Response", $client->__getLastResponse());
	die ("<HTML><B>Connessione SOAP non riuscita</B><BR></HTML>\n"); 
}

if (is_null($client)) 
{ 
	die("<HTML><B>Connessione SOAP non riuscita</B><BR></HTML>\n"); 
}

	
if ($output_object->error_code == 0)
{
        $FP = fopen("test.out", "wb");
        fwrite($FP, $output_object->image_res);
        fclose($FP);
}
else
{
        echo "Il server ha restituito errore " . $output_object->error_code . "<br />\n";
}

?>